Wed Feb 11 10:58:13 CET 1998

	- Added '-d' option to turn on debugging.
	- Added version number to ecpg.
	- Made libecpg a shared library.
	- All files are now installed by 'make install'.
	- Added man page.

Thu Feb 12 14:45:07 CET 1998

	- changed parser to correctly handle local variables.

Thu Feb 12 15:55:37 CET 1998

	- allow static and extern variable definitions.
	- free() variable structure completely.

Fri Feb 13 12:35:58 CET 1998

	- ecpg can use structs to store data, but only if the complete
	  definition of the struct lies inside the sql declare section
	  and only simple types used.

Fre Feb 13 14:12:41 CET 1998

	- struct definitions now work completely.

Mon Feb 16 16:17:21 CET 1998

	- enable initialisation in declare section.
	- connect call accepts a variable as well. 

Wed Feb 18 21:41:30 CET 1998

	- added whenever statement

Thu Feb 19 12:48:14 CET 1998

	- added do option to whenever statement

Sat Feb 21 19:10:55 CET 1998

	- use char[] as string not as array of bytes that is integers

Sun Feb 22 16:37:36 CET 1998

	- use long for all size variables
	- added execute immediate statement

Sun Feb 22 20:41:32 CET 1998

	- use varcharsize = 1 for all simple types, 0 means pointer, > 1
	  means array if type is char resp. unsigned char

Thu Feb 24 12:26:12 CET 1998

	- allow 'go to' in whenever statement as well as 'goto'
	- new argument 'stop' for whenever statement

Wed Feb 25 15:46:50 CET 1998

	- corrected whenever continue handling
	- removed whenever break

Fri Feb 27 10:51:38 CET 1998

	- corrected parser to accept '::int2'

Fri Feb 27 12:00:55 CET 1998

	- removed all shift/reduce conflicts
	- allow syntax 'fetch cursor' as well as 'fetch in cursor'

Fri Mar 13 11:37:16 CET 1998

	- finished transaction handling, needs only one function in ecpglib now
	  old functions are still supported for compatibility
	- set library to version 1.1.0

Fri Mar 13 13:35:13 CET 1998

	- exec sql include includes files during parsing
	- set parser to version 1.1.0
	- added -I option to ecpg to set include path

Mon Mar 16 15:09:10 CET 1998

	- fixed parser to print correct filename and line number

Wed Mar 18 14:28:49 CET 1998

	- started working on indicator variables

Mon Mar 23 13:49:15 CET 1998

	- fixed some bugs in indicator variable handling
	- completely rewrote parser for fetch and insert statements
	- indicator variables are also allowed in insert statements now

Mon Mar 23 16:09:05 CET 1998

	- fixed whenever command goto to only allow valid lables

Thu Mar 26 13:33:02 MEZ 1998

	- some minor bugfixes

Mon Apr 20 13:06:09 CEST 1998

	- database name no longer has to entered as string constant, i.e.
	  just remove the '...' around the name

Mon Apr 20 14:38:45 CEST 1998

	- both test cases compile cleanly

Mon Apr 20 16:13:25 CEST 1998

	- Phew! Finally finished parser rewriting.

Mon Apr 20 16:39:23 CEST 1998

	- Cursor is opened when the open command is issued, not at declare time.
	- Set version to 2.0.0

Tue Apr 21 12:53:49 CEST 1998

	- Set indicator to amount of data really written (truncation).

Thu Apr 23 09:27:16 CEST 1998

	- Also allow call in whenever statement with the same functionality
	  as do.

Thu Apr 23 12:29:28 CEST 1998

	- Also rewrote variable declaration part. It is now possible to
	  declare more than one variable per line.
	- Set version to 2.1.0

Fri Apr 24 13:50:15 CEST 1998

	- Fixed some bugs.
	- Set version to 2.1.1

Mon Apr 27 14:26:55 CEST 1998

	- Parser now able to understand and process syntax like :foo->bar
	  and :foo.bar as variables.
	- Set version to 2.2.0

Tue Apr 28 14:48:41 CEST 1998

	- Put operator "->" back into parser. Note that :foo->bar means the
	  C term, but :foo ->bar means the operator "->".

Tue Apr 28 15:49:07 CEST 1998

	- Added exec sql disconnect command.
	- Allow varchar in C to be written in uppercase too.
	- Added whenever option "do break;"

Wed Apr 29 09:17:53 CEST 1998

	- Corrected parsing of C comments.
	- Also allow C++ style comments.
	- Make sure not found is only checked after commands that could
          return it.
	- Added error codes, see ecpgerror.h for details.
	- Added "exec sql <TransactionStmt> release" as disconnect statement
	  for compatibility issues.

Thu Apr 30 10:42:10 CEST 1998

	- Added a -t option to disable automatic transaction start.
	- Added sqlerrd[] to sqlca struct.
	- Give back number of tuples affect in sqlca.sqlerrd[2].

Thu Apr 30 13:36:02 CEST 1998

	- Make the return code different in case of different errors.

Wed May  6 11:42:48 CEST 1998

	- Free memory if possible
	- Some bugfixes for bugs I found while changing the memory
          allocation code
	- Now able to fill complete array with one call (see test1.pgc for
          an example)
	- Set version to 2.3.0
	- Set library version to 2.1

Wed May  6 16:09:45 CEST 1998

	- Some more cleanups in the library.

Thu May  7 12:34:28 CEST 1998

	- Made CONNECT and DISCONNECT statement more SQL3 compliant.
	- Changed the API for the ECPGconnect function to be able to handle
	  hostnames and ports

Fri May  8 13:54:45 CEST 1998
	- More changes to the parser. The connect statement now allows
	  ORACLE style logins.
	- db-name is accepted in two ways:
		- <dbname>[@<server>][:<port>]
		- esql:postgresql://<server>[:<port>][/<dbname>]

Mon May 11 10:28:37 CEST 1998

	- Added '? options' to connect call.
	- Also allow USING as keyword for the password

Thu May 14 15:09:58 CEST 1998

	- Changed preproc.y and pgc.l according to the parser changes in the
	  backend.

Fri May 15 09:55:21 CEST 1998

	- Added connection_name handling


Mon May 18 10:33:58 CEST 1998

	- Fixed some more bugs
	- Set version to 2.3.1
	- Set library version to 2.2

Tue May 19 11:49:34 CEST 1998

	- Tested (and fixed) 'set connection'
	- Fixed string notation in C

Wed May 20 10:46:48 CEST 1998

	- Fixed handling of preprocessor directives and variable
	  initialization.
	- Added enum datatype.
	- Set version to 2.3.2

Wed Jun  3 13:38:57 CEST 1998

	- Made sqlca struct compatible with other systems.
	- Give back a warning in case of truncation
	- Changed the handling of OptimizableStmt since the old one broke
	  CREATE RULE
	- Set library version to 2.3
	- Set version to 2.3.3

Thu Jul  2 20:30:14 CEST 1998

	- Changed new style db name to allow connection types "tcp" and
	  "unix" only

Tue Jul  7 15:14:14 CEST 1998

	- Fixed some bugs in preproc.y
	- Set version to 2.3.4

Mon Jul 27 17:13:11 CEST 1998

	- Changed text of error message to make emacs happy

Mon Aug  3 17:23:18 CEST 1998

	- Added latest changes from gram.y resp. scan.l to
	  preproc.y resp. pgc.l
	- Fixed cursor handling
	- Set version to 2.3.5
	- Set library version to 2.4

Fri Aug  7 12:38:50 CEST 1998

	- Fixed cursor handling once again
	- Added support for variables in cursor
	- Set version to 2.3.6
	- Set library version to 2.5

Fri Aug 14 12:44:21 CEST 1998

	- Added EXEC SQL DEFINE statement
	- Set version to 2.4.0

Tue Aug 18 09:24:15 CEST 1998

	- Removed keyword IS from DEFINE statement
	- Added latest changes from gram.y
	- Removed duplicate symbols from preproc.y
	- Initialize sqlca structure
	- Added check for connection to ecpglib
	- Set version to 2.4.1

Thu Aug 20 15:31:29 CEST 1998

	- Cleaned up memory allocation in ecpglib.c
	- Set library version to 2.6

Wed Aug 26 16:17:39 CEST 1998

	- Sync preproc.y with gram.y

Thu Aug 27 15:32:23 CEST 1998

	- Fix some minor glitches that the AIX compiler complains about
	- Added patchlevel to library

Fri Aug 28 15:36:58 CEST 1998

	- Removed one line of code that AIX complains about since it was not
	  needed anyway
	- Set library version to 2.6.1

Mon Aug 31 09:40:04 CEST 1998

	- Minor patch to Makefile
	- Put pgc.l in sync with scan.l

Tue Sep  1 11:31:05 CEST 1998

	- Fixed another bug in preproc.y

Thu Sep  3 12:21:16 CEST 1998

	- Sync preproc.y with gram.y

Mon Sep 14 09:21:02 CEST 1998

	- Sync preproc.y with gram.y yet again

Thu Sep 17 08:55:33 CEST 1998

	- Synced preproc.y and gram.y one more time

Thu Sep 17 19:23:24 CEST 1998

	- Added missing ';' in preproc.y
	- Set version to 2.4.2

Tue Sep 29 10:22:00 CEST 1998

	- Check strdup calls for out of memory.
	- Set library version to 2.6.2

Wed Sep 30 12:15:10 CEST 1998

	- Synced preproc.y with gram.y yet again.
	- Set version to 2.4.3

Mon Okt 12 12:36:04 CEST 1998

	- Synced preproc.y with gram.y yet again.

Thu Okt 15 10:05:04 CEST 1998

	- Synced preproc.y with gram.y yet again.
        - Set version to 2.4.4

Wed Dec  9 20:24:54 MEZ 1998

	- Synced preproc.y with gram.y and the keywords.c files to add CASE
	  statement.

Tue Dec 22 19:16:11 CET 1998

	- Synced preproc.y with gram.y for locking statements.
	- Set version to 2.4.5

Tue Jan  7 19:19:34 CET 1999

	- Synced preproc.y with gram.y for for-update clause and changes in
	  handling of numerics

Mon Jan 18 19:22:44 CET 1999

	- Added INTERSECT, EXCEPT and UNION for Select statements
	- Put keywords.c in sync again after forgettimg it the last time.

Thu Jan 21 21:29:00 CET 1999

	- Fixed libecpg to not segfault if there is no connection.
	- Set library version to 2.6.3
	- Added 'exec sql whenever sqlwarning'.
	- Set ecpg version to 2.4.6

Wed Jan 27 12:42:22 CET 1999

	- Fixed bug that caused ecpg to lose 'goto' information.
	- Set ecpg version to 2.4.7

Fri Jan 29 18:03:52 CET 1999

	- Fixed bug that caused 'enum' to be rejected in pure C code.
	- Fixed bug that caused function names to be translated to lower case.
	- Set ecpg version to 2.4.8
 
Tue Feb  2 07:40:52 CET 1999

	- Brought preproc.y in sync again with gram.y.
	- Set ecpg version to 2.4.9

Wed Feb  3 18:28:46 CET 1999

	- Started working on PREPARE statement.
	- Fixed typo in preproc that cause CREATE statement to not work
	  anymore.

Thu Feb  4 19:43:39 CET 1999

	- Some parts of the PREPARE statement work now.
	- Added EXECUTE command
	- Added DEALLOCATE PREPARE command

Fri Feb  5 18:25:07 CET 1999

	- PREPARE seems to be working okay now.
	- Fixed some minor bugs.
	- Renamed y.tab.* to preproc.*

Mon Feb  8 07:57:29 CET 1999

	- Synced preproc.y with gram.y again.
	- Allow ':<name>' as positional variable in prepare statement also.
	  You can still specify ';;' instead of course.
	- Added TYPE statement.
	- Set library version to 2.7.0

Tue Feb  9 07:07:11 CET 1999

	- Synced preproc.y with gram.y.

Tue Feb  9 20:21:44 CET 1999

	- Added FREE statement.

Wed Feb 10 07:51:09 CET 1999

	- Synced keyword.c.

Sat Feb 13 10:44:43 CET 1999

	- Added DECLARE STATEMENT for compatibility with Oracle. De facto
	  this statement does nothing.
	- Added VAR statement.

Son Feb 14 11:36:04 CET 1999

	- Added type 'enum' to TYPE and VAR statement. 
	- Allow ecpg keywords as datatypes.

Thu Feb 18 08:35:35 CET 1999

	- Make sure indicator for array is array too.

Fri Feb 19 18:38:45 CET 1999

	- Finished type aliasing for structures.
	- Set ecpg version to 2.5.0

Fri Feb 19 21:40:14 CET 1999

	- Fixed bug in libecpg that caused it to start transactions only for
	  the first connection.
	- Set library version to 2.7.1

Son Feb 21 14:10:47 CET 1999

	- Fixed variable detection in libecpg.

Mon Feb 22 19:47:45 CET 1999

	- Added 'at <db_connection>' option to all commands it is apllicable
	  to. Due to changing the API of some libecpg functions this
	  requires me to increase the major version number of libecpg.
	- Synced pgc.l with scan.l.
	- Added support for unions.

Tue Feb 23 17:32:25 CET 1999

	- Other than a struct a union itself cannot be specified as variable.

Fri Feb 26 07:18:25 CET 1999

	- Synced preproc.y with gram.y.

Sat Feb 27 20:30:03 CET 1999

	- Added automatic allocating for NULL pointers.

Mon Mar  1 20:16:24 CET 1999

	- Fixed parser bug that caused it to miss some blanks during output.

Thu Mar  4 19:49:28 CET 1999

	- Fixed bug in ecpglib.c that caused it to allocate to few memory.
	- Switched memory allocation to calloc() to make sure memory is
	  cleared.
	- Fixed varchar auto-allocating.

Sat Mar  6 14:06:07 CET 1999

	- Replaced placeholder ';;' by '?' since this is what standard says.

Mon Mar  8 17:07:14 CET 1999

	- Corrected include directives to not include backend stuff.

Tue Mar  9 17:26:28 CET 1999

	- Synced preproc.y with gram.y.

Sun Mar 14 15:44:18 CET 1999

	- Synced preproc.y with gram.y.

Thu Mar 18 18:57:31 CET 1999

	- Synced preproc.y with gram.y.
	- Added '%' operator.

Thu Mar 18 19:44:10 CET 1999

	- Added ECPGstatus() function.
	- Cleaned up some error messages.

Fri Mar 19 08:49:32 CET 1999

	- Synced preproc.y with gram.y.
	- Synced keywords.c.
	- Synced pgc.l with scan.l.

Sat Mar 20 19:57:42 CET 1999

	- Synced preproc.y with gram.y.
	- Fixed handling of ';' character.

Sun Mar 21 13:05:50 CET 1999

	- Synced preproc.y with gram.y.

Mon Mar 22 19:22:38 CET 1999

	- Fixed incorrect password entry in parser.
	- Made no_auto_trans available for each connection seperately.

Sat Apr 10 20:10:50 CEST 1999

	- Allow ecpg handle a floating point constants.
	- Fix ecpg runtime library memory leak (patch by Masaaki Sakaida).

Mon Apr 12 17:56:14 CEST 1999

	- Fixed ECPG variable handling.
	- Make no_auto_trans be accessible via SET command.
	- Do not eat comments so line numbering should be correct.
	
Wed Apr 14 17:59:06 CEST 1999

	- Added simple calculations for array bounds.

Fri Apr 16 18:25:18 CEST 1999

	- Fixed small bug in ECPGfinish().

Sat Apr 24 12:39:07 CEST 1999

	- Synced preproc.y with gram.y.
	- Allow more than one blank between EXEC and SQL.
	- Allow statements to be prepared from a character string, too.

Fri May  7 07:11:38 CEST 1999

	- Synced preproc.y with gram.y.
	- Fixed small bug in parser.

Thu May 13 13:51:26 CEST 1999

	- Synced preproc.y with gram.y.

Mon May 17 18:13:30 CEST 1999

	- Synced preproc.y with gram.y.

Fri May 21 18:13:44 CEST 1999

	- Synced preproc.y with gram.y.

Sun May 23 11:19:32 CEST 1999

	- Add braces around each statement so that a simple if/else works.

Thu Jun 10 21:09:12 CEST 1999

	- Fixed typo in preproc.y.
	- Synced pgc.l with scan.l.

Wed Jun 16 20:21:42 CEST 1999

	- Fixed another typo in preproc.y.

Thu Jun 24 18:06:43 CEST 1999

	- Fixed C comment bug that caused ecpg to not accept quoted quotes.

Fri Jun 25 07:17:10 CEST 1999

	- Changed error message in ecpglib.c to list correct database name.
	- Set library version to 3.0.0
	- Set ecpg version to 2.6.0

Mon Jul 19 07:53:20 CEST 1999

	- Synced preproc.y with gram.y.
	- Synced pgc.l with scan.l.
	- Fixed quoting bug in ecpglib.c
	- Set ecpg version to 2.6.1
	- Set library version to 3.0.1

Sun Aug  1 13:31:19 CEST 1999

	- Synced preproc.y with gram.y.
	- Set ecpg version to 2.6.2

Tue Sep 14 22:26:40 CEST 1999

	- Added patch by Andreas Theofilu <theofilu@eunet.at> to fix yet
          another quoting bug.
	- Minor bugfixes to ecpg
	- Return OID in sqlca.sqlerrd[1] if possible.
	- Set ecpg version to 2.6.3
	- Set library version to 3.0.2

Fri Sep 17 07:43:55 CEST 1999

	- Fixed bug in parsing C strings.
	- Fixed bug in parsing operators.
	- Set ecpg version to 2.6.4

Fri Sep 17 18:16:34 CEST 1999

	- Made sure sqlca is initialized everytime.
	- Set library version to 3.0.3

Mon Sep 27 07:40:20 CEST 1999

	- Synced preproc.y with gram.y.
	- Synced keyword.c.
	- Set ecpg version to 2.6.5

Tue Sep 28 17:58:37 CEST 1999

	- Synced preproc.y with gram.y.
	- Synced pgc.l with scan.l.

Fri Oct  1 18:34:30 CEST 1999

	- Synced preproc.y with gram.y.
	- Synced keyword.c.
	- Include patch by Christof Petig <christof.petig@wtal.de>:
		- made NULL a valid bool value
		- check for indicator variables on NULL

Wed Oct  6 18:28:40 CEST 1999

	- Synced preproc.y with gram.y.

Thu Oct  7 15:12:58 CEST 1999

	- Fixed bug that caused mixed case relation names to be converted to
	  upper case.
	- Synced preproc.y with gram.y.
	- Set ecpg version to 2.6.6
	- Set library version to 3.0.4

Tue Oct 12 07:26:50 CEST 1999

	- Simplified C part of parser.

Fri Oct 15 17:05:25 CEST 1999

	- Synced preproc.y with gram.y.
	- Synced pgc.l with scan.l.
        - Synced keyword.c.
	- Finished C parser changes, so initializers are correctly parsed.
	- Set ecpg version to 2.6.7

Mon Oct 25 09:28:17 CEST 1999

	- Made sure Tom Lane's patches make it into my source tree.

Wed Oct 27 18:08:09 CEST 1999

	- Synced preproc.y with gram.y.
	- Set ecpg version to 2.6.8

Fri Oct 29 21:36:25 CEST 1999

	- Fixed bug that caused ecpg to not allow FOR UPDATE.
	- Set ecpg version to 2.6.9

Mon Nov  1 11:22:06 CET 1999

	- Print SQL error message to STDERR instead of STDOUT.
	- Added a fourth test source.
	- Set library version to 3.0.5.

Wed Nov 10 18:33:14 CET 1999

	- Synced preproc.y with gram.y.

Thu Nov 11 07:49:44 CET 1999

	- Fixed bug in SET AUTOCOMMIT.

Mon Nov 22 18:26:34 CET 1999

	- Synced preproc.y with gram.y.
	- Clean up parser.
	- Set library version to 3.0.6.
        - Set ecpg version to 2.6.10.

Tue Nov 23 07:59:01 CET 1999

	- Ignore locale setting in ECPGdo.
	- Set library version to 3.0.7.

Fri Dec  3 16:35:07 CET 1999

	- Fixed memory leak in ecpglib.
	- Set library version to 3.0.8.

Wed Dec  8 08:26:13 CET 1999

	- Synced preproc.y with gram.y.
	- Clean up error handling.
        - Set ecpg version to 2.6.11.

Tue Dec 14 07:28:10 CET 1999

	- Synced preproc.y with gram.y.
	- Simplified string handling.

Wed Dec 15 08:10:52 CET 1999

	- Fixed typo in parser.
	- Included Bruce's patch to fix two more memory leaks in libecpg.
	- Some cleanup in libecpg.
	- Set library version to 3.0.9.
	- Set ecpg version to 2.6.12.

Thu Dec 23 13:25:05 CET 1999

	- Fixed command line parsing. 
	- Set ecpg version to 2.6.13.

Thu Jan  6 09:52:27 CET 2000

	- Synced preproc.y with gram.y.
	- Set ecpg version to 2.6.14.

Wed Jan 12 15:50:39 CET 2000

	- Made sure Rene Hogendoorn's patches make it into ecpg completely
	  except for the FETCH syntax change.

Fri Jan 14 21:17:46 CET 2000

	- Applied a minor patch to ecpglib.c.
	- Fixed initialization bugs.

Mon Jan 17 21:55:40 CET 2000

	- Synced preproc.y with gram.y.
	- Changed FETCH syntax using Rene's final patch. Made it more
	  standard compliant.

Thu Jan 20 10:00:50 CET 2000

	- Synced preproc.y with gram.y.

Fri Jan 21 14:52:27 CET 2000

	- Added more log output to ecpglib.

Thu Jan 27 08:12:05 CET 2000

	- Added another patch by Rene Hogendoorn.
	- Fixed error messages in pgc.l.
	- Improved variable parsing.
	- Synced preproc.y with gram.y.

Mon Feb 14 10:35:18 CET 2000

	- Synced preproc.y with gram.y.

Tue Feb 15 11:14:07 CET 2000

	- Synced keyword.c.
	- Synced preproc.y with gram.y.

Tue Feb 15 17:39:19 CET 2000

	- Do only write the first 70 bytes of the error message to the 
	  sqlca structure since there are only 70 bytes free space.
	- Set library version to 3.0.10.

Wed Feb 16 11:57:02 CET 2000

	- Fixed library to be able to input complete arrays.

Wed Feb 16 17:04:41 CET 2000

	- Apply patch by Christof Petig <christof.petig@wtal.de> that adds
	  descriptors.

Thu Feb 17 19:37:44 CET 2000

	- Synced preproc.y with gram.y.
	- Started to clean up preproc.y.

Tue Feb 22 13:48:18 CET 2000

	- Synced preproc.y with gram.y.
	- Much more clean ups.

Wed Feb 23 17:08:28 CET 2000

	- Even more clean ups.

Fri Feb 25 16:13:11 CET 2000

	- Fixed some bugs I created when I cleaned up, thanks Christof.

Wed Mar  1 10:49:03 CET 2000

	- Synced preproc.y with gram.y.
	- Added output of arrays.

Thu Mar  2 11:25:09 CET 2000

	- Fixed some parsing problems. A variable can now be a reserved
	  SQL keyword.
	- Made sure double quotes in statements are correctly quoted.

Thu Mar  2 17:42:16 CET 2000

	- Print error message if an indicator array is given for input
	  variables.

Fri Mar  3 10:47:06 CET 2000

	- Fixed handling of double quote in C code.

Tue Mar  7 10:58:21 CET 2000

	- More cleanup in ecpglib.
	- Fixed ecpg.c not not free variable list twice.

Thu Mar  9 10:12:57 CET 2000

	- Fixed another memory bug in the parser.

Wed Mar 15 17:36:02 CET 2000

	- Synced preproc.y with gram.y.
	- Synced pgc.l with scan.l.
	- Synced keyword.c.

Sun Mar 19 11:03:13 CET 2000

	- Fixed quoting bug in disconnect statement.

Thu Mar 23 08:13:39 CET 2000

	- Synced preproc.y and keyword.c.

Wed Mar 29 09:03:26 CEST 2000

	- Fixed string parsing bug in pgc.l.

Thu Mar 30 11:11:13 CEST 2000

	- Synced preproc.y with gram.y.
	- Fixed comment parsing bug.

Fri Mar 31 08:25:58 CEST 2000

	- Synced preproc.y with gram.y.

Mon Apr  3 21:20:27 CEST 2000

	- Made sure pointers are correctly inserted by libecpg. My thanks go
	  to Jan Urbanek <jan@urbanek.cz> for findin many bugs before the
	  release. 

Wed Apr  5 07:54:56 CEST 2000

	- Added patch by Peter Eisentraut <e99re41@DoCS.UU.SE> to fix some
	  duplicate definittions in preproc.y.
	- Removed duplicate ',' in execute.c.
	- Changed error message for backend errors so it fits into sqlca.
	- Fixed array handling.

Wed Apr  5 17:35:53 CEST 2000

	- Fixed handling of bool variables.

Sat Apr  8 13:10:12 CEST 2000

	- Synced preproc.y with gram.y.
	- Synced keyword.c.
	- Set library version to 3.1.0.
	- Set ecpg version to 2.7.0.

Mon May 15 10:51:31 CEST 2000

	- Added patch by SAKAIDA Masaaki <sakaida@psn.co.jp> to fix segfault.
	- Set ecpg version to 2.7.1.

Wed May 17 07:52:59 CEST 2000

	- Added patch by SAKAIDA Masaaki <sakaida@psn.co.jp> to fix array
	  handling.
	- Set library version to 3.1.1.

Mon Sep  4 14:10:38 CEST 2000

	- Synced preproc.y with gram.y.  
	- Synced keyword.c. 

Mon Sep 18 13:55:11 CEST 2000

	- Added int8 support based on a patch by Martijn Schoemaker <martijn@osp.nl>

Wed Sep 20 12:40:27 CEST 2000

	- Added patch by Christof Petig <christof.petig@wtal.de> to process
	  backend NOTICEs.
	- Added patch by Christof Petig <christof.petig@wtal.de> to cache
	  type information.

Thu Sep 21 13:54:13 CEST 2000

	- Enabled parser to accept ip addresses instead of host names.

Tue Sep 26 13:00:16 CEST 2000

	- Synced preproc.y with gram.y.
        - Synced keyword.c.   
	- Added patch by Christof Petig <christof.petig@wtal.de> to fix NOT
	  FOUND problem on update/insert/delete.

Wed Oct  4 14:36:51 CEST 2000

	- Added patch by Christof Petig <christof.petig@wtal.de> to fix
	  missing NOTICE.

Wed Oct 11 16:49:36 CEST 2000

	- Synced preproc.y with gram.y.

Thu Oct 12 20:13:00 CEST 2000

	- Changed parser to accept a variable instead of a constant wherever
	  possible.

Mon Oct 16 21:33:17 CEST 2000

	- Fixed handling of variables in connect rule.

Tue Oct 17 08:09:16 CEST 2000

	- Simplified parsing of connect rule.

Tue Oct 17 17:36:30 CEST 2000

	- Fixed some bugs in C language parsing. 

Sun Oct 22 15:35:53 CEST 2000

	- Fixed typos in descriptor.c.

Wed Oct 25 08:53:07 CEST 2000

	- Added some more C constructs to the parser.

Wed Oct 25 21:22:17 CEST 2000

	- Synced gram.y and preproc.y.

Son Oct 29 11:26:06 CET 2000

	- Removed multibyte stuff since client does not know about encoding
	  in the backend.
	- Fixed quoting bug reported by Sascha Demetrio (sd@b-comp.de).

Mon Oct 30 15:27:12 CET 2000

	- Synced gram.y and preproc.y. 

Tue Oct 31 16:09:55 CET 2000

	- Added patch by Christof Petig <christof.petig@wtal.de> fixing some
	  parser bugs.

Fri Nov  3 11:34:43 CET 2000

	- Synced pgc.l with scan.l.
	- Synced gram.y and preproc.y.

Sat Nov  4 17:42:43 CET 2000

	- Added patch by Christof Petig to fix several small bugs.

Thu Nov  9 14:40:18 CET 2000

	- Synced gram.y and preproc.y. 
	- Synced keyword.c.
	- Added just another patch by Christof Petig.

Sat Nov 18 16:28:11 CET 2000

	- Synced gram.y and preproc.y.         

Mon Dec 18 12:27:52 CET 2000

	- Synced gram.y and preproc.y.
	- Synced keyword.c.
	- Added several small patches from Christof.

Fri Dec 22 13:33:31 CET 2000

	- Fixed bug in a connect statement using varchars.
	- Synced gram.y and preproc.y.   

Mon Jan 22 17:56:02 CET 2001

	- Synced gram.y and preproc.y.   
	- Added #include "postgres.h" to pgc.l.

Tue Jan 23 08:54:14 CET 2001

	- Moved database name handling to libecpg.

Thu Jan 25 21:14:38 CET 2001

	- Synced gram.y and preproc.y.     

Wed Jan 31 17:11:04 CET 2001

	- Added two bug fixes by Christof Petig.

Mon Feb 19 08:25:14 CET 2001

	- Synced gram.y and preproc.y.

Mon Feb 26 15:22:04 CET 2001

	- Fixed misplaced variables FoundInto and QueryIsRule.

Thu Mar 29 10:23:05 CEST 2001

	- Applied bug fix in ecpgtype.h by Adriaan Joubert.

Mon Apr  2 10:16:10 CEST 2001

	- Synced scan.l and pgc.l.

Thu Apr  5 10:11:35 CEST 2001

	- Fixed long long problem.
	- Set ecpg version to 2.8.0. 
	- Set library version to 3.2.0.

Fri Jun  1 08:13:25 CEST 2001

	- Synced preproc.y with gram.y.
	- Synced pgc.l with scan.l.
	- Synced keyword.c.

Wed Jun 13 14:39:12 CEST 2001

	- Synced preproc.y with gram.y.  
	- Applied bug fix by John Summerfield.

Son Aug 19 11:04:39 CEST 2001

	- Synced preproc.y with gram.y. 
	- Include some patches by Christof Petig <christof.petig@wtal.de>.

Wed Sep 19 15:57:49 CEST 2001

	- Synced preproc.y with gram.y. 
	- Synced pgc.l with scan.l.
        - Synced keyword.c.
	- Include the remaining patches by Christof Petig <christof.petig@wtal.de>.

Tue Sep 25 20:10:03 CEST 2001

	- Synced preproc.y with gram.y.
	- Changed locale handling.

Mon Oct  1 13:49:40 CEST 2001

	- Fixed truncate bug.
	- Added patch by Christof Petig <christof.petig@wtal.de> to clean up
	  ecpglib.

TUe Oct  2 16:09:26 CEST 2001

	- Re-added Tom's patch fixing my setlocale patch. I accidently
	  deleted it.

Fri Oct  5 08:37:01 CEST 2001

	- Fixed yet another typo in preproc.y.

Fri Oct  5 19:33:46 CEST 2001

	- Make sure every call to ECPGraise is logged.

Mon Oct  8 10:10:23 CEST 2001

	- Fix include file so library is binary compatible again.

Sun Oct 14 14:07:59 CEST 2001

	- Fixed GRANT statement.
	- Synced preproc.y with gram.y.

Thu Oct 18 12:57:04 CEST 2001

	- Added patch by Lee Kindness <lkindness@csl.co.uk> fixing several
	  bugs.

Fri Oct 19 16:32:06 CEST 2001

	- Removed "not yet fully implemented" warnig for nullif.

Sun Oct 21 14:19:42 CEST 2001

	- Synced preproc.y with gram.y.

Fri Nov  2 16:16:25 CET 2001

	- Synced preproc.y with gram.y.

Wed Nov 14 11:50:27 CET 2001

	- Added several patches by Christof Petig <christof.petig@wtal.de>.

Tue Dec  4 13:30:32 CET 2001

	- Fixed dumping of structures without indicators.

Wed Dec  5 12:27:25 CET 2001

	- Fixed variable handling in AT statement.
	- Fixed bug that caused segfault when given incorrect DB name.
	- Fixed bug in ecpglib causing indicator to list the size of the
	  variable instead of the size of the data

Thu Dec  6 14:02:56 CET 2001

	- Removed debug message from preproc.y.
	- Fixed some bugs in exec sql var and exec sql type command.

Sat Dec  8 21:35:45 CET 2001

	- Fix ecpg to allow pointer to structs.

Sun Dec  9 16:21:30 CET 2001

	- Fixed several bugs concerning indicators and added error messages
	  instead of segfaults.

Thu Dec 20 14:15:56 CET 2001

	- Removed space_or_nl and line_end from pgc.l.

Sun Dec 23 13:08:36 CET 2001

	- Fixed several bugs concerning arrays of structs including a memory
	  allocation bug.

Mon Jan  7 12:18:01 CET 2002

	- Fixed parser to accept initializing expressions starting with "(".

Tue Jan  8 15:16:37 CET 2002

	- Fixed array pointers, no longer using void *.

Thu Jan 10 11:12:14 CET 2002

	- Include sqlca.h automatically.

Fri Jan 11 15:43:39 CET 2002

	- clear sqlca on : [de]allocate descriptor  & get descriptor and set
	  sqlca.sqlerrd[2] accordingly (Christof).

Sat Jan 12 22:04:02 CET 2002

	- Fixed variable handling for struct members.
	- Removed check for array input. An attribut might store the
	  complete array.

Fri Jan 18 16:49:02 CET 2002

	- Accept subsequent commits.

Wed Jan 23 17:35:23 CET 2002

	- Added patch to temporarily disable locale for descriptors too (Christof).
	- Set ecpg version to 2.9.0.
        - Set library version to 3.3.0.

Wed Mar  6 10:40:28 CET 2002

	- Synced preproc.y with gram.y.

Sun Mar 10 13:08:22 CET 2002

	- Fixed two bugs in define command in lexer.

Thu Mar 21 08:25:08 CET 2002

	- Applied patch by Nicolas Bazin <nbazin@ingenico.com.au> for improved
	  typedef handling.
	- Added option '-c' to automatically create C typedef from SQL one.

Sun Apr 14 10:53:14 CEST 2002

	- Fixed one bug in structure handling resulting in using sizeof
	  indicator instead of variable.
	- Synced preproc.y with gram.y.

Mon Apr 22 20:44:56 CEST 2002
	
	- Synced preproc.y with gram.y.
	- Synced keywords.c.

Sun Apr 28 19:16:40 CEST 2002

	- Synced preproc.y with gram.y.
	- Fixed typo in comment printed by ecpg.

Sun May 19 19:21:34 CEST 2002

	- Fixed reduce/reduce conflict in parser.
	- Synced preproc.y with gram.y.
	- Synced pgc.l with scan.l.
	- Synced keywords.c.

Mon May 20 10:58:36 CEST 2002

	- Fixed some parser bugs.
	- Removed some simple rules to work arounf bison limit for now.
	- Update c_keywords.c to reflect changes in keywords.c.

Wed Jun 12 14:04:11 CEST 2002

	- Applied Lee Kindness' patch to fix one of memory allocation with
	  floating point numbers.
	
Mon Jun 17 15:23:51 CEST 2002

	- Fixed parser bug in pgc.l. Octal numbers in single quotes are now
	  correctly handled.

Tue Jun 18 15:13:15 CEST 2002

        - Fixed parser bug concerning foreign keys.
        - Synced preproc.y with gram.y.
        - Synced pgc.l with scan.l.
        - Synced keywords.c.
	
Sun Aug 18 16:09:06 CEST 2002

        - Synced preproc.y with gram.y.
        - Synced pgc.l with scan.l.
        - Synced keywords.c.

Tue Aug 20 14:13:34 CEST 2002

	- Removed ',' from preproc.y for bison 1.49b.

Sun Sep  1 11:13:04 CEST 2002

        - Synced preproc.y with gram.y.
        - Synced keywords.c.

Wed Sep 11 10:43:17 CEST 2002

	- Synced preproc.y with gram.y.


Fri Sep 20 07:57:42 CEST 2002

	- Synced preproc.y with gram.y.
	- Synced keywords.c.
	- Deactivated backend functions PREPARE, EXECUTE and DEALLOCATE for
	  the time being.

Thu Nov  7 10:34:07 CET 2002

	- Synced preproc.y with gram.y.
	- Set ecpg version to 2.10.0.
	- Set library version to 3.4.0.

Fri Nov 15 16:46:08 CET 2002

	- Synced preproc.y with gram.y.


Wed Nov 27 09:28:54 CET 2002

	- Synced preproc.y with gram.y.

Tue Jan 21 20:50:58 CET 2003

	- Set ecpg version to 2.11.0.
	- Synced preproc.y with gram.y.

Thu Feb 13 14:06:28 CET 2003

	- Applied patch by Matthew Vanecek <mevanecek@yahoo.com> for better
	  error reporting.
	- Started working on an Informix compatibility mode. With option "-C
	  INFORMIX" set, ecpg now accepts "$" as alias for "exec sql" and to
	  denote variables inside SQL statements.


Fri Feb 14 14:14:25 CET 2003

	- Synced parser and keyword file.
	- More work on Informix compatibility. 

Mon Feb 17 15:07:41 CET 2003

	- Added Informix "database" command.

Wed Feb 19 13:39:29 CET 2003

	- Added DATABASE command as alias to CONNECT TO.
	- Fixed struct parsing bug.

Tue Feb 25 16:46:27 CET 2003

	- Allow SET CONNECTION to be followed by connection object without
	  leading "TO" or "=".
	- Allow whenever statement to list function without parameters.


Sun Mar 16 11:28:01 CET 2003
	
	- Started with a pgtypes library.
	- Renamed lib directory to ecpglib.
	- Added numerical functions to library and preprocessor.

Thu Mar 20 16:53:40 CET 2003

	- Added date/timestamp to library and preprocessor.

Fri Mar 21 15:13:42 CET 2003

	- Made sure preprocessor accepts new datatypes.
	- Do not free prepared statements at the end of a transaction.


Thu Mar 27 15:23:58 CET 2003

	- Some more updates to pgtypeslib.
	- Set optimization to -O1 until I find the reason why code is broken
	  with -O2.

Sat Mar 29 22:03:16 CET 2003

	- Moved Informix compatibility stuff its own library.
	- Added interval datetypes.

Sun Mar 30 13:43:13 CEST 2003

	- Interval datetype now fully functional.

Tue Apr  8 14:03:32 CEST 2003

	- Added rstrdate function.
	- Made Informix mode honor environment variable to set dbname to
	  connect to.

Thu May  1 14:54:41 CEST 2003

	- Enable more Informix shortcuts.
	- Added option '-i' to parse files included via cpp diretive as well.

Fri May  2 16:37:06 CEST 2003

	- Fixed double definition of compat_mode.

Tue May  6 11:51:33 CEST 2003

	- Added rfmtlong compatibility function.

Tue May 13 13:34:12 CEST 2003

	- Fixed order of include search path.
	
Wed May 14 13:05:49 CEST 2003

	- Added more compatibility functions.
	- Accept CPP defines for type definitions.
	- Do not parse system include files automatically for Informix mode

Fri May 16 11:45:50 CEST 2003

	- Fixed include in pgtypeslib to not include c.h

Fri May 16 13:32:10 CEST 2003

	- Made double variables work again.
	
Mon May 19 09:22:40 CEST 2003

	- Fixed exec sql ifdef command.

Tue May 20 11:47:00 CEST 2003

	- Reversed my fix for ifdef. It was the example, not ecpg which was
	  incorrect.
	- Changed DBPATH variable to PG_DBPATH.
	
Thu May 22 09:33:54 CEST 2003

	- ecpg now recognizes named struct/union usage.

Fri May 23 11:46:15 CEST 2003

	- Synced parser and keyword table.
	- ecpg now accepts array elements as input variables.

Tue May 27 13:29:28 CEST 2003

	- Fixed incorrect output for some structs.
	
Tue May 27 16:33:36 CEST 2003

	- Accept stdin/stdout as input/output file.
	
Thu May 29 13:58:25 CEST 2003

	- ecpg should now be able to parse forward struct definition.
	
Thu May 29 15:45:57 CEST 2003

	- Changed parsing of variables to be able to reference one attribute
	  of the n-th entry in an array of structs.
	  
Fri May 30 10:29:49 CEST 2003

	- Synced parser.
	- Added a dummy rule for EXEC SQL DESCRIBE that throws an error
	  message.
	  
Fri May 30 15:19:39 CEST 2003

	- Implemented prototype describe function.
	- Some minor cleanup/bug fixing.
	
Mon Jun  2 17:36:03 CEST 2003

	- Fixed segfault in forward definition parsing.
	
Tue Jun 10 19:43:49 CEST 2003

	- Fixed several small bugs.
	
Wed Jun 11 08:30:41 CEST 2003

	- Make sure a variable is no longer referenced when it is removed.
	- Fixed counting bug in parsing "->" operator.
	
Fri Jun 13 10:11:12 CEST 2003

	- Enable FETCH without INTO.
	- Compatibility functions for INFORMIX handling of DECLARE statement.

Sun Jun 15 11:18:58 CEST 2003

	- Applied multi-threading patch by Lee Kindess <lkindness@csl.co.uk>
	- Changed order of types in enum to make working with these easier.
	
Tue Jun 17 08:45:14 CEST 2003

	- Fixed several parsing bugs.
	
Thu Jun 19 10:08:26 CEST 2003

	- Added missing rdayofweek function for Informix compatibility.
	- Fixed fetch into char pointer.
	
Fri Jun 20 13:23:07 CEST 2003

	- Enabled constants in using clause.
	
Fri Jun 20 15:34:29 CEST 2003

	- For Informix compatibility we have to accept a "free <cursor>".
	- Synced scan.l and pgc.l.
	
Sun Jun 22 11:20:29 CEST 2003

	- Fixed missing '\0' in output char pointer.
	
Wed Jun 25 09:29:34 CEST 2003

	- Synced keyword.x and preproc.y/gram.y.
	- Implemented Informix special way to treat NULLs.
	
Thu Jun 26 13:26:13 CEST 2003

	- Added another compatibility level INFORMIX_SE.
	- Synced again.
	
Sun Jun 29 11:22:48 CEST 2003

	- Just another sync.
	- Made sure Informix style decimal vars are initialized. They use a
	  fixed amount of digits and not an allocated one. So we have to work
	  around. PostgreSQL numeric type remains the same.
	- In INFORMIX_SE mode with autcommit set, make all cursors be "with
	  hold". Is this really they way SE behaves?
	  
Tue Jul  1 11:57:56 CEST 2003

	- Use ISO dates in pgtypeslib by default.
	- Applied patch by Philip Yarra to fix some thread issues.
	- Added a new data type "decimal" which is mostly the same as our
	  "numeric" but uses a fixed length array to store the digits. This is
	  for compatibility with Informix and maybe others.
	  
Wed Jul  2 09:45:59 CEST 2003

	- Fixed initialization bug in compatlib.
	- Added postgres_fe.h to all files in pgtypeslib.
	
Fri Jul  4 13:51:11 CEST 2003

	- date, interval and timestamp data should be quoted. 
	
Mon Jul  7 14:13:43 CEST 2003

	- Made sure "char *" is handled differently than "char []".
	
Tue Jul  8 09:04:31 CEST 2003

	- Fixed segfault in ECPGconnect in Informix mode.
	
Tue Jul  8 12:34:00 CEST 2003

	- Made Informix decimal-ascii conversion honor Informix NULLs.
	- Informix variable handling didn't cope well with arrays.
	
Wed Jul  9 11:45:02 CEST 2003

	- Made all Informix functions honor Informix NULLs.
	- Extended compatibility functions for INFORMIX handling of DECLARE
	  statement to work with indicators.
	  
Mon Jul 14 09:34:04 CEST 2003

	- Synced preproc.y with gram.y
	- Init sqlca in ECPGprepare().
	- Added CLOSE DATABASE for Informix compatibility.
	
Tue Jul 15 14:28:53 CEST 2003

	- Started to add error codes for backend error messages.
	
Thu Jul 17 09:15:59 CEST 2003

	- Fixed some bugs in informix compat functions.
	
Fri Jul 18 16:31:10 CEST 2003

	- Added some more compatibility features to the parser.
	
Thu Jul 24 10:33:51 CEST 2003

	- Fixed mdy functions to use correct offset.
	
Fri Jul 25 18:08:18 CEST 2003

	- Added explicit casts for date/timestamp/interval.
	
Fri Aug  1 08:54:02 CEST 2003
	
	- Added some Informix error codes in Informix mode.
	- Added just another pgtypeslib function.

Mon Aug 25 13:24:27 CEST 2003

	- Synced parser.
	
Tue Aug 26 18:06:45 CEST 2003

	- Fixed processing of connect statement with username as variable.
	
Mon Sep  1 14:33:10 CEST 2003

	- Fixed two bugs in numeric library.

Tue Sep  9 12:13:51 CEST 2003

	- Added Dave patch for Informix handling of numeric/int conversion.
	- Changed all new datatypes to lowercase.
	- Fixed rounding bug in numerical types.
	
Wed Sep 10 20:01:49 CEST 2003

	- Some files still had uppercase typenames
	
Mon Sep 15 18:09:42 CEST 2003

	- Accept output variables for FETCH in DECLARE statement.
	
Tue Sep 16 07:56:14 CEST 2003

	- Synced parser.
	- Allowed C variables to carry the name of prepared statements.
	
Thu Sep 18 14:54:47 CEST 2003

	- Added Informix handling of datatype converion errors.
	
Fri Sep 19 08:33:39 CEST 2003

	- Some code cleanup
	
Sat Sep 20 11:06:13 CEST 2003

	- Applied some bug fixing patches by Dave Cramer <dave@fastcrypt.com>.
	- Added protecting defines to include files.
	- Renamed my own strndup() function because of a name clash.
	
Mon Sep 22 15:13:02 CEST 2003

	- Fixed order mismatch in processing "using" arguments.
	- Fixed some minor things in test cases.
	- Use defines for Informix error codes.

Tue Sep 23 14:50:45 CEST 2003

	- Changed struct definition handling so "struct foo {}" always gets
	  defined.
	  
Fri Sep 26 17:14:07 CEST 2003

	- Incorrect datatype with precision argument should not create a
	  segfault.
	  
Fri Oct  3 12:04:57 CEST 2003

	- Hide Informix datatypes in PostgreSQL built process.
	
Sun Oct  5 13:08:47 CEST 2003

	- Fixed bug in day of week calculation.
	
Mon Oct  6 08:41:45 CEST 2003

	- Fixed constant listing in execute using clause.
	- Fixed typo in ecpg for Informix dec_t type.
	- Fixed precision handling in Informix compat funxtions.
	
Tue Oct  7 07:45:09 CEST 2003

	- Fixed error handling in rstrdate.
	
Tue Oct  7 20:26:06 CEST 2003

	- Fixed floating point exception in long=>numeric transformation.
	
Sun Oct 19 15:20:16 CEST 2003

	- Need to check for both Informic compat modes when parsing include
	  files.
	  
Mon Oct 20 14:53:40 CEST 2003

	- Install dummy sqlda.h file.
	
Sun Oct 26 10:47:05 CET 2003

	- Fixed bug with indicators when storage for the
	  string is dynamically allocated
	  
Thu Oct 30 11:12:37 CET 2003

	- Applied patch by Dave Cramer fixing several bugs in compatlib.
	
Fri Oct 31 15:09:22 CET 2003

	- If EOF is found inside a string/comment/etc. stop parsing.
	
Mon Nov  3 15:43:19 CET 2003

	- Fixed a potentially uncleared allocation in compatlib.
	- Set ecpg version to 3.0.0
	- Set ecpg library to 4.0.0
	- Set pgtypes library to 1.0.0
	- Set compat library to 1.0.0

Wed Dec  3 09:45:21 CET 2003

	- Added patch for array handling by Dave Cramer
	
Wed Dec 17 16:11:16 CET 2003

	- Added just another patch by Dave that fixes a reversed order in
	  variable listing for output variables in cursor definitions
	- Fixed incorrect if call in long=>numeric conversion.
	- Set ecpg version to 3.1.0
	- Set ecpg library to 4.1
	- Set pgtypes library to 1.1
	- Set compat library to 1.1

Mon Jan 26 21:57:14 CET 2004

	- Issue a warning if a cursor is declared but not opened.
	- Fixed prototype for ECPGprepared_statement to not moan about "const
	  char"
	- Fixed parsing of nested structures.
	- Added option to parse header files.

Sun Feb 15 14:44:14 CET 2004

	- Added missing braces to array parsing.
	- Allowed some C keywords to be used as SQL column names.
	
Mon Feb 16 08:17:19 CET 2004

	- Cleaned up parser a little bit. It does not make sense to allow a
	  typename to be typedef'ed that cannot be parsed as variable type.
	- Allowed some SQL keywords to be used as C variable names.

Tue Feb 24 16:48:57 CET 2004

	- Corrected error handling in PGTYPEStimestamp_from_asc.
	
Mon Mar  1 08:56:37 CET 2004
	
	- Added partly missing VOLATILE keyword.
	
Thu Mar  4 08:29:02 CET 2004

	- Fixed segfault due to missing check for variable declaration.
	- Added check for multidimensional array usage.
	
Sun Mar 14 12:59:15 CET 2004

	- Fixed Informix compat math functions to cope with the situations
	  where one argument takes the result.
	- Applied thread patches by Lee Kindness
	
Mon Mar 29 17:02:52 CEST 2004

	- Fixed possible segfault in type.c (by Juergen Cappel)
	
Thu Apr 22 14:13:57 CEST 2004

	- Fixed double usage of allocated memory.
	
Thu Apr 29 16:06:37 CEST 2004

	- Synced parser and keyword list.
	
Wed May  5 11:51:47 CEST 2004

	- Fixed bug in adjust_informix that treated arrays as simple
	  variables.
	- Synced parser again.
	- Synced lexer.
	
Fri May  7 15:34:05 CEST 2004

	- Added portability file to pgtypeslib.
	- Fixed bug that reversed string length in typedefs.
	- Added additional test case.
	
Mon May 10 15:38:58 CEST 2004

	- Argh, just another bug in adjust_informix.
	- Added "extern C" flags for C++ compiler.

Fri May 21 15:17:35 CEST 2004
	
	- Fixed DEALLOCATE PREPARE to use correct function call
	- Made sure connect statement does not accept single char variable,
	  but only strings.
	  
Sat May 22 13:11:12 CEST 2004

	- Added pg_config_paths.h to ecpglib.
	
Thu Jun 17 13:50:06 CEST 2004

	- Added patch by ISHIDA Akio to allow indicators in execute
	  statements.
	  
Sun Jun 20 12:44:01 CEST 2004

	- Synced parser and keyword list.
	
Sun Jun 27 13:50:58 CEST 2004
	
	- Only use typedefs inside their scope.
	- Variables that are out of scope, were not removed all the time.
	- Make a varchar NULL set everything to 0 when not using indicators.
	- Synced parser.
	
Mon Jun 28 11:08:42 CEST 2004

	- Arrays can be read as arrays or as character strings now.
	
Wed Jun 30 16:56:32 CEST 2004

	- Added SET DESCRIPTOR command. 
	- Cleaned up error handling in preprocessor.
	
Sun Jul  4 16:53:53 CEST 2004

	- Made sure SET DESCRIPTOR accepts all data types including constants.
	- Some code cleanup.
	
Mon,  5 Jul 2004 10:41:54 +0200

	- Fixed indicator in SET DESCRIPTOR.
	- Added special handling of descriptor header information.
	- More code cleanup.
	
Mon Jul  5 20:50:09 CEST 2004

	- Added free() calls against memory leak in interval.c.
	
Tue Jul 20 09:15:21 CEST 2004

	- Synced parser and keyword list.
	- Fixed handling of cyclic defines.
	
Mon Jul 26 09:04:53 CEST 2004

	- SQL defines are only used in SQL space in Informix mode.
	
Mon Sep  6 13:17:46 CEST 2004

	- Fixed bug in Informix mode that caused a segfault.
	- Set pgtypes library version to 1.2.
	
Mon Sep 27 11:05:49 CEST 2004

	- Synced parser.
	- Removed Oracle transaction syntax to fix shift/reduce error.
	
Tue Oct  5 12:45:48 CEST 2004

	- '::' is no longer interpreted as a variable in a prepare statement.
	  Added patch by Daniel Verite to fix this.
	  
Mon Oct 18 15:34:51 CEST 2004

	- Synced parser.
	
Wed Nov 10 14:43:50 CET 2004

	- List VALUE as a keyword.
	
Mon Dec  6 21:27:34 CET 2004
	
	- Fixed bug in parsing of typedef'ed array sizes.
	- Synced parser.
	
Thu Dec 23 09:26:08 CET 2004

	- Added PGTYPEStimestamp_add_interval written by Dave Cramer.
	- Fixed parsing of defines to make sure they used more than once.	
	
Mon Jan 10 13:55:32 CET 2005
	
	- Fixed segfault in adjust_informix due to missing varchar type.
	- Set ecpg version to 3.2.0.
	- Set compat library version to 1.2.
	- Set ecpg library version to 4.2.

Tue Jan 25 13:47:45 CET 2005

	- Fixed segfault in preprocessor due to free a struct twice.

Wed Feb  2 16:35:27 CET 2005

	- Fixed bug in parsing of #line statement in declare section.
	
Wed Feb  9 12:24:03 CET 2005

	- Fixed bug in parsing of CREATE AS statement.

Thu Feb 10 09:03:56 CET 2005

	- Fixed more parsing bugs in other CREATE statements. Thanks to TANIDA
	  Yutaka <tanida@sra.co.jp> and Atsushi Mitani <mitani@sraw.co.jp> for
	  pointing out all these problems.
	- Set ecpg version to 3.2.1.

Fri Mar 18 10:54:47 CET 2005
	  
	- Added patch by Christof Petig <christof@petig-baender.de> to work
	  around gcc bug on powerpc and amd64.

Thu Apr 14 11:59:47 CEST 2005

	- Added patch by Philip Yarra <philip.yarra@internode.on.net> for a
	  bug in thread support.

Thu Jun  2 14:22:32 CEST 2005

	- Fixed memory leak in ecpglib by adding some missing free() commands.
	- Added patch by Gavin Scott <gavin@planetacetech.com> for Intel 64bit
	  hardware.

Wed Aug 24 12:17:48 CEST 2005

	- Check for NULL before checking whether argument is an array.
	- Remove stray character from string quoting.
	- Fixed check to report missing varchar pointer implementation.

Mon Sep 12 13:53:35 CEST 2005

	- Fixed transaction command handling to not ignore savepoints
	  and to correctly check for errors.

Tue Oct  4 15:23:00 CEST 2005

	- Synced parser.
	- Fixed another bug in check to report missing varchar pointer implementation.

Wed Oct  5 16:57:42 CEST 2005

	- Synced lexer.
	- Set ecpg library version to 5.1.
	- Set ecpg version to 4.1.1.

Wed Nov 30 12:49:13 CET 2005

	- Made several variables "const char *" instead of "char *" as
	  proposed by Qingqing Zhou <zhouqq@cs.toronto.edu>.
	- Replaced all strdup() calls by ECPGstrdup().

Fri Dec  2 16:00:10 CET 2005

	- Added special handling of CONNECTION variable that is used by ECPG
	  instead of given to the backend.
	  
Fr Jan 13 17:29:30 CET 2006

	- Fixed a fixed size buffer in preproc.y to be variable size since an
	  overflow could occur on the fixed one.
	  
Tu Jan 17 18:53:03 CET 2006

	- Data transferred binary is now put into the variables verbatim.
	
Tu Jan 24 10:59:21 CET 2006

	- Synced parser and keyword list.
	- Added another test case.
	
Sa Feb  4 21:35:03 CET 2006

	- Added C bit fields to ecpg parser.
	- Added some default rules to lexer.
	- Added log output to prepare statement.
	
Mo Feb  6 21:21:19 CET 2006

	- Added just another test case.
	- Fixed missing continuation line character.
	- Do not translate $-quoting.
	
Tu Feb  7 18:48:14 CET 2006

	- Bit field notation belongs to a variable not a variable list.
	- Output of line number only done by one function.

Fri, 17 Mar 2006 16:38:19 +0100

	- Fixed bug 2330: Wrong error code in case of a duplicate key.

Mo Apr 24 11:40:05 CEST 2006

	- Fixed memory leak bugs found by Martijn Oosterhout.

We Mai 31 10:10:36 CEST 2006

	- Fixed PGTYPESdate_from_timestamp because some characters got lost there.

Tu Jun  6 12:09:56 CEST 2006

	- Fixed two more memory leaks in ecpglib.
	- Synced parser.

Mo Jun 19 11:15:50 CEST 2006

	- Do not use already free'ed errmsg, bug found by Joachim Wieland
	  <joe@mcknight.de>.

We Jun 21 09:24:53 CEST 2006

	- Added fixes from the coverity report send in by Joachim Wieland
	  <joe@mcknight.de>.
	- Added missing error handling in a few functions in ecpglib.

we Jun 21 13:37:00 CEST 2006

	- Added some more coverity report patches send in by Martijn van
	  Oosterhout <kleptog@svana.org>.

Su Jun 25 11:27:46 CEST 2006

	- Moved some free() calls that coverity correctly complains about.

Mo Jun 26 11:05:25 CEST 2006

	- Added some more coverity report patches send in by Joachim Wieland
	  <joe@mcknight.de>.

Mo Jun 26 16:08:23 CEST 2006

	- Added missing braces to prevent a segfault after usage of an
	  undeclared cursor.

We Jul  5 12:17:28 CEST 2006

	- Fixed most of the remaining Coverity bugs.

Fr Jul 28 11:00:51 CEST 2006

	- Added more SoC changes by Joachim Wieland <joe@mcknight.de>:
		- SHOW statement puts result into a variable
		- COPY TO STDOUT works
		- Connection identifier has to be unique
	- Variables should be free'ed only once.

Tu Aug  1 15:04:52 CEST 2006

	- Applied patch by Joachim Wieland <joe@mcknight.de> to fix segfault
	  occuring when using --enable-thread-safety.

We Aug  2 13:15:25 CEST 2006

	- Synced parser and keyword list.
	- Implemented EXEC SQL UNDEF.
	- Applied first version of the regression test patch by Joachim
	  Wieland <joe@mcknight.de>.

Fr Aug  4 10:44:30 CEST 2006

	- Applied test suite update by Joachim Wieland <joe@mcknight.de>.

Mo Aug  7 14:56:44 CEST 2006

	- Joachim fixed some bugs in numeric handling in pgtypeslib.

Tu Aug  8 13:26:25 CEST 2006

	- Made parser check for valid copy to/from stdin/stdout combinations.

We Aug  9 09:28:56 CEST 2006

	- Fixed error handling in numeric conversion (Joachim).
	- Fixed some memory bugs that somehow reappeared.
	- Also fixed a new Coverity report.

Su Aug 13 11:01:13 CEST 2006

	- Applied patch for VPATH builds by Alvaro Herrera
	  <alvherre@commandprompt.com>
	- Merged dyntest.pgc and dyntest2.pgc.

Mo Aug 14 10:39:59 CEST 2006

	- Added lots of SoC stuff made by Joachim.
	- Fixed broken newline on Windows.
	- Fixed a nasty buffer underrun that only occured when using Informix
	  no_indicator NULL setting on timestamps and intervals.

Fr Aug 18 17:32:54 CEST 2006

	- Changed lexer to no longer use the default rule.
	- Synced parser and keyword list.
	- Fixed parsing of CONNECT statement so it accepts a C string again.
	- Fixed a buffer overrun that was masked on Linux systems.

Sa Aug 19 14:11:32 CEST 2006

	- More SoC stuff.

Tu Aug 22 13:54:08 CEST 2006

	- Descriptor values were quoted twice.

We Aug 23 09:32:14 CEST 2006

	- Replaced double-quote-fix with a hopefully better version.
	- Use initializer string length as size for character strings.
	- Added ecpg_config.h file that is created via configure.

Th Aug 24 11:53:29 CEST 2006

	- Fixed of by one variable size.
	- Synced parser.

Su Aug 27 17:54:36 CEST 2006

	- Enabled single-quoted connection targets.
	- Fixed a memory leak/segfault in unsuccessful connection.

Tu Aug 29 14:21:31 CEST 2006

	- Fixed parser and library to allow empty database names.
	- Streamlined connection name parsing.

Su Sep 3 14:21:29 CEST 2006

	- Synced parser.
	- Added another regression test and fixed tcp test.

Tu Sep 5 11:49:08 CEST 2006

	- Synced parser.
	- Fixed ecpglib trying to read one character after end-of-string.
	- Fixed port number setting in regression suite.
	- Added some interval checks to regression suite.
	- Started to cleanup complex tests.

Th Sep 14 09:47:03 CEST 2006

	- Completely removed complex tests.
	- Added missing constuctor/destructor for interval and date.

We Nov 8 10:53:42 CET 2006

	- Applied patch by Peter Harris to free auto_mem struct in ECPGconnect.
	- Set ecpg library version to 5.2.
	- Set ecpg version to 4.2.1.

Th Jan 25 17:17:01 CET 2007

	- Removed compiler warning due to unneeded unsigned declaration.
	- Removed regression test that triggers those libc precision bugs on some archs.

Fr Feb 2 09:53:48 CET 2007

	- Cleaned up va_list handling. Hopefully this now works on all archs.
	- Applied Magnus Hagander's patch to take away some compiler warnings.

Su Feb 11 16:09:31 CET 2007

	- Fixed multibyte handling as reported by <harada.toshi@oss.ntt.co.jp>.

Th Mar 15 08:27:53 CET 2007

	- Made some chars const as proposed by Stefan Huehner <stefan@huehner.org>.
	- Synced parser and keyword lists.
	- Copied two token parsing from backend parser to ecpg parser.
	- Also added a test case for this.

Thu, 29 Mar 2007 11:18:39 +0200

	- Added patch by Magnus Hagander <magnus@hagander.net> to use native
	  win32 threads.
	- Fixed regression tests to run threading tests.

Fri, 27 Apr 08:55:25 CEST 2007

	- Inlined two functions to get rid of va_list problems on some
	  architectures.

Thu, 10 May 09:42:42 CEST 2007

	- Synced parser and keyword list.
	- Renamed update test so it hopefully runs on Vista.
	
Sun, 20 May 2007 22:01:11 +0200

	- Do not try to find local timezone in DecodeDateTime() because the
	  result is not used anyway. This also fixes Vista's build problems.

Sun, 27 May 2007 13:14:39 +0200

	- Changed variable test to not run into infinite loops on backend
	  errors.

Mon, 11 Jun 2007 13:59:57 +0200

	- Fixed memory leak in descriptor code.
	- Made ecpg delete output file in case of an error.

Tue, 12 Jun 2007 09:46:03 +0200

	- Synced parser and keyword list.

Wed, 25 Jul 2007 15:34:54 +0200

	- Synced parser.

Tue, 14 Aug 2007 11:46:51 +0200

	- Finished major rewrite to use new protocol version.
	- Really prepare statements.
	- Added more regression tests.
	- Added auto-prepare mode.
	- Use '$n' for positional variables, '?' is still possible via ecpg
	  option.
	- Cleaned up the sources a little bit.

Wed, 22 Aug 2007 08:41:33 +0200

	- More cleaning up and removed some duplicates.

Wed, 29 Aug 2007 15:41:58 +0200

	- Fixed bug in Informix define handling.

Tue, 04 Sep 2007 11:13:55 +0200

	- Synced parser and keyword list.

Mi 26. Sep 12:45:51 CEST 2007

	- Applied patch by ITAGAKI Takahiro <itagaki.takahiro@oss.ntt.co.jp>
	  to get prepare thread-safe.

Sun, 30 Sep 2007 13:37:31 +0200

	- Applied another patch by ITAGAKI Takahiro <itagaki.takahiro@oss.ntt.co.jp>
	  to get memory allocation thread-safe. He also did some cleaning up.

Tue, 02 Oct 2007 11:32:25 +0200

	- ITAGAKI Takahiro <itagaki.takahiro@oss.ntt.co.jp> added thread-safe
	  descriptor handling
	
Wed, 03 Oct 2007 10:48:39 +0200

	- Hopefully fixed some stuff that causes Windows builds to fail.
	- Cleaned up ecpglib and renamed functions that do not need to be
	  exported.
	- Created export list for ecpglib.
	- Also created export list for pgytpeslib and compatlib.
	
Wed, 10 Oct 2007 08:31:44 +0200
	
	- Synced parser and keyword list.

Tue, 06 Nov 2007 09:29:22 +0100

	- Fixed two parser bugs.

Fri, 21 Dec 2007 15:30:39 +0100

	- Fixed a few minor glitches pointed out by splint.

Fri, 28 Dec 2007 12:15:38 +0100

	- Applied patch send by ITAGAKI Takahiro
	  <itagaki.takahiro@oss.ntt.co.jp> to fix bug in connect statement if
	  user name is a variable. 
	- Also fixed test case that didn't detect this.

Fri, 11 Jan 2008 16:16:24 +0100

	- Fixed lexer to correctly parse C quotes.

Sun, 13 Jan 2008 12:52:15 +0100

	- Changed prototype for ECPGdo because some compilers don't like
	  int/enum aliasing in there.

Mon, 14 Jan 2008 10:42:23 +0100

	- Set valid return values even in case of an error to prevent
	  segfaults.

Tue, 15 Jan 2008 11:26:14 +0100

	- Re-enabled variables in fetch/move command.
	- Set pgtypes library version to 3.0.
	- Set compat library version to 3.0.
	- Set ecpg library version to 6.0.
	- Set ecpg version to 4.4.

Wed, 06 Feb 2008 09:04:48 +0100

	- Fixed segfault in ecpg when using an array element.
	- Free all memory in auto-prepare mode.

Thu, 14 Feb 2008 13:11:34 +0100

	- Added SQLSTATE macro closing bug #3961.
	- EXECUTE can return NOT FOUND so it should be checked here too.
	- Changed regression test accordingly.

Fri, 15 Feb 2008 12:01:13 +0100

	- Changed the way symbols are defined in C in INFORMIX mode.

Sun, 17 Feb 2008 18:45:39 +0100

	- Removed duplicate include of ecpgtype.h.
	- Changed INFORMIX mode symbol definition yet again because the old
	  way didn't work on NetBSD.

Sun, 02 Mar 2008 11:50:48 +0100

	- Fixed bug that caused arrays of varchar to be output with incomplete
	  name.

Thu, 20 Mar 2008 16:54:27 +0100

	- Changed statement escaping to not escape continuation line markers.
	- Added ECPGget_PGconn() function to ecpglib, courtesy of Mike Aubury.

Tue, 25 Mar 2008 13:42:26 +0100

	- Should list ECPGget_PGconn in exports.txt.

Wed, 26 Mar 2008 17:02:08 +0100

	- Moved from PQsetdbLogin to PQconnectDB.
	- Correctly parse connect options.

Thu, 10 Apr 2008 12:42:25 +0200

	- Fixed bug in PGTYPEStimestamp_sub that used pointers instead of the
	  values to substract.

Mon, 12 May 2008 18:19:08 +0200

	- Check for non-existant connection in prepare statement handling.
	- Do not close files that weren't opened.

Tue, 20 May 2008 17:31:01 +0200

	- Synced parser.
	- Made ecpg parser use backend provided keyword list. One less file to
	  sync manually.
	- Changed whenever test so exit value is 0.

Wed, 04 Jun 2008 14:22:30 +0200

	- Added lost symbol SQL to list of allowed variable names.
	- Set pgtypes library version to 3.1.
	- Set compat library version to 3.1.
	- Set ecpg library version to 6.2.
	- Set ecpg version to 4.5.

